package it.danieleverducci.subitobeers

import android.os.Bundle
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import it.danieleverducci.subitobeers.entities.Beer

/**
 * A fragment representing a list of Items.
 */
class BeersFragment : Fragment(), BeersRepository.Listener {

    private val rvAdapter = BeerRecyclerAdapter()

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        val view = inflater.inflate(R.layout.fragment_beers_list, container, false)

        // Set the adapter
        if (view is RecyclerView) {
            with(view) {
                layoutManager = LinearLayoutManager(context)
                adapter = rvAdapter
            }
        }
        return view
    }

    override fun onStart() {
        super.onStart()

        // Load beers from network
        val repo = BeersRepository()
        repo.listener = this
        repo.getBeers(1)
    }

    override fun onBeersObtained(beers: List<Beer>) {
        rvAdapter.addItems(beers)
    }

    override fun onFailure() {
        Toast.makeText(context, R.string.network_error, Toast.LENGTH_SHORT).show()
    }

}