package it.danieleverducci.subitobeers

import android.util.Log
import android.widget.Toast
import it.danieleverducci.subitobeers.entities.Beer
import it.danieleverducci.subitobeers.networking.RetrofitProvider
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class BeersRepository {

    companion object {
        val TAG = "BeersRepository"
    }

    var listener: Listener? = null

    fun getBeers(page: Int) {
        // Obtain beers
        val call = RetrofitProvider.getClient.getBeers(page)
        call.enqueue(object: Callback<List<Beer>> {
            override fun onResponse(call: Call<List<Beer>>, response: Response<List<Beer>>) {
                if (response.body() != null)
                    listener?.onBeersObtained(response.body()!!)
                else
                    listener?.onFailure()
            }

            override fun onFailure(call: Call<List<Beer>>, t: Throwable) {
                if (t.message != null)
                    Log.e(TAG, "Unable to obtain beers: ${t.message!!}")
                listener?.onFailure()
            }
        })
    }

    interface Listener {
        fun onBeersObtained(beers: List<Beer>)
        fun onFailure()
    }
}